## mingw-w64-pdal-2.8.0-1.src.tar.zst

=== doc/requirements.txt ===
sphinx==7.4.7
breathe==4.35.0
sphinxcontrib-bibtex==2.6.2
sphinx-rtd-theme==2.0.0
sphinxcontrib-spelling==8.0.0
sphinx-notfound-page==1.0.4

=== plugins/cpd/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

if (STANDALONE)
    project(pdal-cpd)
    include("${CMAKE_CURRENT_LIST_DIR}/../../cmake/standalone.cmake" )
    find_package(PDAL REQUIRED)
endif(STANDALONE)

set(Cpd_VERSION 0.5)

find_package(Cpd ${Cpd_VERSION} REQUIRED CONFIG)
find_package(Fgt REQUIRED CONFIG)
option(BUILD_PLUGIN_CPD "Build Coherent Point Drift support" ${Cpd_FOUND})

set(files filters/CpdFilter.cpp)
set(include_dirs "${CMAKE_CURRENT_LIST_DIR}" "${PDAL_VENDOR_DIR}/eigen")

PDAL_ADD_PLUGIN(filter_libname filter cpd
    FILES
        filters/CpdFilter.cpp
    LINK_WITH
        Cpd::Library-C++
        ${PDAL_LIBRARIES}
    INCLUDES
        ${PDAL_VENDOR_DIR}/eigen
        ${CMAKE_CURRENT_LIST_DIR}
    )

if(${WITH_TESTS})
    PDAL_ADD_TEST(pdal_filters_cpd_test
        FILES
            test/CpdFilterTest.cpp
        LINK_WITH
            ${filter_libname}
            Cpd::Library-C++
        INCLUDES
            "${include_dirs}"
        )
endif()

=== plugins/faux/CMakeLists.txt ===
#
# FauxPlugin CMake configuration
#

PDAL_ADD_PLUGIN(fauxplugin_kernel_libname kernel fauxplugin
    FILES
        kernel/FauxPluginKernel.cpp
)

=== plugins/mbio/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

if (STANDALONE)
    project(pdal-mbio)
    include(../../cmake/standalone.cmake NO_POLICY_SCOPE)
endif(STANDALONE)

#
# MBIO plugin CMake configuration (MB-System)
#

find_package(MBSystem)
if (MBSYSTEM_FOUND)
    PDAL_ADD_PLUGIN(reader_libname reader mbio
        FILES
            io/MbReader.cpp
            io/MbFormat.cpp
            io/MbError.cpp
        LINK_WITH
            ${MBSYSTEM_LIBRARY}
            ${PDAL_LIBRARIES}
        INCLUDES
            ${PDAL_IO_DIR}
            ${MBSYSTEM_INCLUDE_DIR}
    )
    target_compile_definitions(${reader_libname} PRIVATE -DHAVE_MBSYSTEM=1)

    if (WITH_TESTS)
        PDAL_ADD_TEST(mbsystemtest
            FILES
                test/MBSystemTest.cpp
            LINK_WITH
                ${reader_libname}
            INCLUDES
                ${PDAL_IO_DIR}
        )
    endif()
else()
    message(STATUS "Building without MB-Sytem support")
endif()

=== plugins/nitf/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

if (STANDALONE)
    project(pdal-nitf)
    include("${CMAKE_CURRENT_LIST_DIR}/../../cmake/standalone.cmake" )
    include(${PDAL_CMAKE_DIR}/arbiter.cmake)
    include(${PDAL_CMAKE_DIR}/nlohmann.cmake)
    add_subdirectory("${PROJECT_SOURCE_DIR}/../../vendor/arbiter" "vendor/arbiter")
    find_package(PDAL REQUIRED)
endif(STANDALONE)

#
# NITF plugin CMake configuration
#

include(${PDAL_CMAKE_DIR}/nitro.cmake)
include(${PDAL_CMAKE_DIR}/arbiter.cmake)
if (NOT NITRO_FOUND)
    message(FATAL_ERROR "Can't find NITRO support required by NITF.")
endif()

PDAL_ADD_PLUGIN(reader_libname reader nitf
    FILES
        io/NitfFileReader.cpp
        io/MetadataReader.cpp
        io/tre_plugins.cpp
        io/NitfReader.cpp
    INCLUDES
        ${GDAL_INCLUDE_DIR}
        ${PDAL_VENDOR_DIR}
        ${NLOHMANN_INCLUDE_DIR}
    LINK_WITH
        ${NITRO_LIBRARIES}
        ${PDAL_ARBITER_LIB_NAME}
        ${PDAL_LIBRARIES}
)
if (WIN32)
    target_compile_definitions(${reader_libname}
        PRIVATE
            WIN32
            _HAS_AUTO_PTR_ETC=1
    )
endif()

PDAL_ADD_PLUGIN(writer_libname writer nitf
    FILES
        io/NitfFileWriter.cpp
        io/NitfWriter.cpp
        io/MetadataReader.cpp
        io/tre_plugins.cpp
    LINK_WITH
        ${NITRO_LIBRARIES}
        ${GDAL_LIBRARY}
        ${PDAL_LIBRARIES}
        ${PDAL_ARBITER_LIB_NAME}
    INCLUDES
        ${GDAL_INCLUDE_DIR}
)
if (WIN32)
    target_compile_definitions(${writer_libname}
        PRIVATE
            WIN32
            _HAS_AUTO_PTR_ETC=1
    )
endif()

if (WITH_TESTS AND NOT STANDALONE)
    PDAL_ADD_TEST(pdal_io_nitf_writer_test
        FILES
            test/NitfWriterTest.cpp
        LINK_WITH
            ${writer_libname}
    )

    PDAL_ADD_TEST(pdal_io_nitf_reader_test
        FILES
            test/NitfReaderTest.cpp
        LINK_WITH
            ${reader_libname}
    )
endif()

=== plugins/teaser/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

if (STANDALONE)
    include(../../cmake/standalone.cmake NO_POLICY_SCOPE)
    find_package(PDAL REQUIRED)
endif(STANDALONE)

find_package(OpenMP QUIET REQUIRED)
set_package_properties(OpenMP PROPERTIES
    TYPE OPTIONAL
    URL "https://www.openmp.org"
    PURPOSE "TEASER++ support")
mark_as_advanced(CLEAR OpenMP_INCLUDE_DIRS)
mark_as_advanced(CLEAR OpenMP_LIBRARIES)
if(NOT OpenMP_CXX_FOUND)
    message(FATAL_ERROR "This project requires the OpenMP library.")
endif()

find_package(teaserpp REQUIRED)
set_package_properties(teaserpp PROPERTIES
    TYPE OPTIONAL
    URL "https://teaser.readthedocs.io/en/latest/"
    PURPOSE "TEASER++ support")
mark_as_advanced(CLEAR teaserpp_INCLUDE_DIRS)
mark_as_advanced(CLEAR teaserpp_LIBRARIES)
if (NOT teaserpp_FOUND)
    message(FATAL_ERROR "This project requires the TEASER++ library.")
endif()

#find_package(PDAL REQUIRED CONFIG)
#if (NOT PDAL_FOUND)
#  message(FATAL_ERROR "This project requires the PDAL library, and will not be compiled.")
#endif()

find_package(PCL 1.9 REQUIRED COMPONENTS common features kdtree)
set_package_properties(PCL PROPERTIES
    TYPE OPTIONAL
    URL "https://pointclouds.org/"
    PURPOSE "TEASER++ support")
mark_as_advanced(CLEAR PCL_INCLUDE_DIRS)
mark_as_advanced(CLEAR PCL_LIBRARIES)
if (NOT PCL_FOUND)
    message(FATAL_ERROR "This project requires the Point Cloud Library.")
endif()

#include_directories(${PDAL_INCLUDE_DIRS})
#add_library(pdal_plugin_filter_teaser SHARED TeaserFilter.cpp)
#link_directories(${PDAL_LIBRARY_DIRS})
#target_link_libraries(pdal_plugin_filter_teaser ${PDAL_LIBRARIES} teaserpp::teaser_registration teaserpp::teaser_features OpenMP::OpenMP_CXX ${PCL_LIBRARIES})

PDAL_ADD_PLUGIN(filter_libname filter teaser
    FILES
        filters/TeaserFilter.cpp
    LINK_WITH
        teaserpp::teaser_registration
	teaserpp::teaser_features
	OpenMP::OpenMP_CXX
	${PCL_LIBRARIES}
    INCLUDES
        ${CMAKE_CURRENT_LIST_DIR}
)

if (WITH_TESTS)
    PDAL_ADD_TEST(pdal_filters_teaser_test
        FILES
            test/TeaserFilterTest.cpp
        LINK_WITH
            ${filter_libname}
        INCLUDES
            "${PDAL_VENDOR_DIR}/eigen"
    )
endif()

=== tools/lasdump/CMakeLists.txt ===

cmake_minimum_required(VERSION 3.5)

add_executable(lasdump
    Dumper.cpp
    Header.cpp
    ${PDAL_UTIL_DIR}/Bounds.cpp
    ${PDAL_UTIL_DIR}/FileUtils.cpp
    ${PDAL_UTIL_DIR}/Utils.cpp
)

target_link_libraries(lasdump PRIVATE
    ${PDAL_LAZPERF_LIB_NAME}
)
target_include_directories(lasdump PRIVATE
    ${PDAL_VENDOR_DIR}
    ${PDAL_INCLUDE_DIR}
    ${NLOHMANN_INCLUDE_DIR}
    ${UTFCPP_INCLUDE_DIR}
)

#
# For byte-ordering functions
#
if (WIN32)
    target_link_libraries(lasdump PRIVATE wsock32 ws2_32)
endif()

PDAL_TARGET_COMPILE_SETTINGS(lasdump)

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=pdal
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=2.8.0
pkgrel=1
pkgdesc="A C++ library for translating and manipulating point cloud data (mingw-w64)"
arch=(any)
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://www.pdal.io"
msys2_repository_url="https://github.com/PDAL/PDAL"
msys2_references=(
  'archlinux: pdal'
)
license=('spdx:BSD-3-Clause')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-curl"
         "${MINGW_PACKAGE_PREFIX}-gdal"
         "${MINGW_PACKAGE_PREFIX}-libgeotiff"
         "${MINGW_PACKAGE_PREFIX}-libxml2"
         "${MINGW_PACKAGE_PREFIX}-openssl"
         "${MINGW_PACKAGE_PREFIX}-proj"
         "${MINGW_PACKAGE_PREFIX}-xz"
         "${MINGW_PACKAGE_PREFIX}-zlib"
         "${MINGW_PACKAGE_PREFIX}-zstd")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-pkgconf"
             "${MINGW_PACKAGE_PREFIX}-draco"
             "${MINGW_PACKAGE_PREFIX}-hdf5"
             "${MINGW_PACKAGE_PREFIX}-postgresql"
             "${MINGW_PACKAGE_PREFIX}-tiledb")
optdepends=("${MINGW_PACKAGE_PREFIX}-draco: Draco plugin, Read data in the draco format"
            "${MINGW_PACKAGE_PREFIX}-hdf5: HDF plugin, read data in the HDF format"
            "${MINGW_PACKAGE_PREFIX}-postgresql: PostgreSQL PointCloud plugin, read/write PostgreSQL PointCloud objects"
            "${MINGW_PACKAGE_PREFIX}-tiledb: TileDB plugin, read/write data from TileDB")
source=("https://github.com/PDAL/PDAL/releases/download/${pkgver}/PDAL-${pkgver}-src.tar.bz2")
sha256sums=('8a6d7646912a4e7a382f06451b14a1f5f2e8aa4e0b391dc91c30701222198b77')

build() {
  mkdir -p "${srcdir}"/build-${MSYSTEM} && cd "${srcdir}"/build-${MSYSTEM}

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  "${MINGW_PREFIX}"/bin/cmake.exe \
    -Wno-dev \
    -GNinja \
    "${_extra_config[@]}" \
    -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
    -DBUILD_SHARED_LIBS=ON \
    -DCMAKE_DLL_NAME_WITH_SOVERSION=ON \
    -DWITH_TESTS=OFF \
    -DBUILD_PLUGIN_DRACO=ON \
    -DBUILD_PLUGIN_HDF=ON \
    -DBUILD_PLUGIN_ICEBRIDGE=ON \
    -DBUILD_PLUGIN_PGPOINTCLOUD=ON \
    -DBUILD_PLUGIN_TILEDB=ON \
    -DWITH_BACKTRACE=OFF \
    -DWITH_LZMA=ON \
    ../PDAL-${pkgver}-src

  "${MINGW_PREFIX}"/bin/cmake.exe --build .
}

package() {
  cd "${srcdir}"/build-${MSYSTEM}
  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install .

  install -Dm644 "${srcdir}"/PDAL-${pkgver}-src/LICENSE.txt \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}
